using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Borland.Eco.Handles;
using Borland.Eco.Windows.Forms;
using Borland.Eco.WinForm;
using Borland.Eco.ObjectRepresentation;
using Borland.Eco.Services;
using PlexityHide.GTP;

namespace ECOSample1
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components;
		private Borland.Eco.Handles.ReferenceHandle rhRoot;
		private Borland.Eco.WinForm.EcoActionExtender EcoGlobalActions;
		private Borland.Eco.WinForm.EcoDragDropExtender EcoDragDrop;
		private Borland.Eco.WinForm.EcoAutoFormExtender EcoAutoForms;
		private Borland.Eco.WinForm.EcoListActionExtender EcoListActions;
		private ECOSample1EcoSpace m_EcoSpace;
		private PlexityHide.GTP.Gantt gantt1;
		private Borland.Eco.Handles.ExpressionHandle expressionHandle_projects;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mi_proj_New;
		private System.Windows.Forms.MenuItem mi_proj_Del;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem mi_ta_New;
		private System.Windows.Forms.MenuItem mi_ta_Del;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem mi_wi_New;
		private System.Windows.Forms.MenuItem mi_wi_Del;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mi_AutoForm;
		public ECOSample1EcoSpace EcoSpace {
			get { return m_EcoSpace; }
		}

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_EcoSpace = new ECOSample1EcoSpace();
			rhRoot.EcoSpace = m_EcoSpace;
			// The line below will automatically activate the ECO Space on form creation.
			// Remove the line if you wish to activate the EcoSpace manually
			m_EcoSpace.Active = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			PlexityHide.GTP.CellLayout cellLayout11 = new PlexityHide.GTP.CellLayout();
			PlexityHide.GTP.LineOption lineOption11 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption12 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption13 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption14 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.CellLayout cellLayout12 = new PlexityHide.GTP.CellLayout();
			PlexityHide.GTP.LineOption lineOption15 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption16 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption17 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption18 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.CellLayout cellLayout13 = new PlexityHide.GTP.CellLayout();
			PlexityHide.GTP.LineOption lineOption19 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption110 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption111 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.LineOption lineOption112 = new PlexityHide.GTP.LineOption();
			PlexityHide.GTP.GridColumn gridColumn11 = new PlexityHide.GTP.GridColumn();
			PlexityHide.GTP.TimeItemLayout timeItemLayout11 = new PlexityHide.GTP.TimeItemLayout();
			PlexityHide.GTP.TimeItemLayout timeItemLayout12 = new PlexityHide.GTP.TimeItemLayout();
			Borland.Eco.Handles.OclColumn oclColumn11 = new Borland.Eco.Handles.OclColumn();
			Borland.Eco.Handles.EventDerivedColumn eventDerivedColumn11 = new Borland.Eco.Handles.EventDerivedColumn();
			Borland.Eco.Handles.EventDerivedColumn eventDerivedColumn12 = new Borland.Eco.Handles.EventDerivedColumn();
			this.rhRoot = new Borland.Eco.Handles.ReferenceHandle();
			this.EcoListActions = new Borland.Eco.WinForm.EcoListActionExtender();
			this.EcoDragDrop = new Borland.Eco.WinForm.EcoDragDropExtender();
			this.EcoGlobalActions = new Borland.Eco.WinForm.EcoActionExtender();
			this.EcoAutoForms = new Borland.Eco.WinForm.EcoAutoFormExtender();
			this.gantt1 = new PlexityHide.GTP.Gantt(this.components);
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mi_proj_New = new System.Windows.Forms.MenuItem();
			this.mi_proj_Del = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.mi_ta_New = new System.Windows.Forms.MenuItem();
			this.mi_ta_Del = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.mi_wi_New = new System.Windows.Forms.MenuItem();
			this.mi_wi_Del = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mi_AutoForm = new System.Windows.Forms.MenuItem();
			this.expressionHandle_projects = new Borland.Eco.Handles.ExpressionHandle();
			this.SuspendLayout();
			// 
			// rhRoot
			// 
			this.rhRoot.EcoSpaceType = typeof(ECOSample1.ECOSample1EcoSpace);
			// 
			// EcoGlobalActions
			// 
			this.EcoGlobalActions.RootHandle = this.rhRoot;
			// 
			// gantt1
			// 
			this.gantt1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
						| System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.gantt1.BackColor = System.Drawing.Color.White;
			this.gantt1.CollisionDetectionSyncron = false;
			this.gantt1.ContextMenu = this.contextMenu1;
			this.gantt1.DateScalerHeight = 48;
			this.gantt1.DateScalerProperties.FishEyeColor = System.Drawing.Color.AliceBlue;
			this.gantt1.DateScalerProperties.FishEyeenabled = false;
			this.gantt1.DateScalerProperties.FishEyeMagnification = PlexityHide.GTP.FishEyeMagnification.M1;
			this.gantt1.DateScalerProperties.LowerBound = new System.DateTime(1000, 1, 1, 0, 0, 0, 0);
			this.gantt1.DateScalerProperties.MarkerTextColor = System.Drawing.Color.Black;
			this.gantt1.DateScalerProperties.ResizeType = PlexityHide.GTP.ResizingType.StartAndStopLocked;
			this.gantt1.DateScalerProperties.ScaleMarkerColor = System.Drawing.Color.Black;
			this.gantt1.DateScalerProperties.ShowWeekNumbers = false;
			this.gantt1.DateScalerProperties.SpanTextColor = System.Drawing.Color.SlateGray;
			this.gantt1.DateScalerProperties.StartOfWeek = System.DayOfWeek.Sunday;
			this.gantt1.DateScalerProperties.StartTime = new System.DateTime(2003, 8, 5, 4, 40, 33, 773);
			this.gantt1.DateScalerProperties.StopTime = new System.DateTime(2003, 9, 5, 7, 13, 44, 862);
			this.gantt1.DateScalerProperties.UpperBound = new System.DateTime(8000, 1, 1, 0, 0, 0, 0);
			this.gantt1.DrawPyjamas = true;
			this.gantt1.FocusedTimeItem = null;
			this.gantt1.GridProperties.AutoCreateColumnsFromDataset = false;
			this.gantt1.GridProperties.BackColor = System.Drawing.Color.White;
			this.gantt1.GridProperties.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.gantt1.GridProperties.BottomColor = System.Drawing.Color.White;
			cellLayout11.BackgroundColor = System.Drawing.Color.White;
			cellLayout11.BackgroundUse = false;
			cellLayout11.DeSelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout11.EndEllipsis = false;
			cellLayout11.Font = new System.Drawing.Font("Times New Roman", 14F);
			cellLayout11.FontColor = System.Drawing.Color.White;
			cellLayout11.HeaderBackgroundColor = System.Drawing.Color.Brown;
			cellLayout11.HeaderBackgroundGradiantColor = System.Drawing.Color.IndianRed;
			cellLayout11.HorzAlign = System.Drawing.StringAlignment.Near;
			cellLayout11.ImageIndex_Select = -1;
			cellLayout11.ImageIndex_UnSelect = -1;
			lineOption11.Color = System.Drawing.Color.LightGray;
			lineOption11.Use = true;
			lineOption11.Width = 1;
			cellLayout11.LineBottom = lineOption11;
			lineOption12.Color = System.Drawing.Color.LightGray;
			lineOption12.Use = false;
			lineOption12.Width = 1;
			cellLayout11.LineLeft = lineOption12;
			lineOption13.Color = System.Drawing.Color.LightGray;
			lineOption13.Use = true;
			lineOption13.Width = 1;
			cellLayout11.LineRight = lineOption13;
			lineOption14.Color = System.Drawing.Color.LightGray;
			lineOption14.Use = false;
			lineOption14.Width = 1;
			cellLayout11.LineTop = lineOption14;
			cellLayout11.MinHeight = 19;
			cellLayout11.Name = "Default";
			cellLayout11.Padding = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout11.SelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout11.Spacing = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout11.VertAlign = System.Drawing.StringAlignment.Near;
			cellLayout12.BackgroundColor = System.Drawing.Color.White;
			cellLayout12.BackgroundUse = false;
			cellLayout12.DeSelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout12.EndEllipsis = false;
			cellLayout12.Font = new System.Drawing.Font("Times New Roman", 14F, System.Drawing.FontStyle.Bold);
			cellLayout12.FontColor = System.Drawing.SystemColors.ControlText;
			cellLayout12.HeaderBackgroundColor = System.Drawing.SystemColors.ControlDark;
			cellLayout12.HeaderBackgroundGradiantColor = System.Drawing.SystemColors.ControlLight;
			cellLayout12.HorzAlign = System.Drawing.StringAlignment.Near;
			cellLayout12.ImageIndex_Select = -1;
			cellLayout12.ImageIndex_UnSelect = -1;
			lineOption15.Color = System.Drawing.Color.LightGray;
			lineOption15.Use = false;
			lineOption15.Width = 1;
			cellLayout12.LineBottom = lineOption15;
			lineOption16.Color = System.Drawing.Color.LightGray;
			lineOption16.Use = false;
			lineOption16.Width = 1;
			cellLayout12.LineLeft = lineOption16;
			lineOption17.Color = System.Drawing.Color.LightGray;
			lineOption17.Use = false;
			lineOption17.Width = 1;
			cellLayout12.LineRight = lineOption17;
			lineOption18.Color = System.Drawing.Color.DimGray;
			lineOption18.Use = true;
			lineOption18.Width = 2;
			cellLayout12.LineTop = lineOption18;
			cellLayout12.MinHeight = 23;
			cellLayout12.Name = "proj";
			cellLayout12.Padding = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout12.SelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout12.Spacing = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout12.VertAlign = System.Drawing.StringAlignment.Center;
			cellLayout13.BackgroundColor = System.Drawing.Color.White;
			cellLayout13.BackgroundUse = false;
			cellLayout13.DeSelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout13.EndEllipsis = false;
			cellLayout13.Font = new System.Drawing.Font("Times New Roman", 10F);
			cellLayout13.FontColor = System.Drawing.SystemColors.ControlText;
			cellLayout13.HeaderBackgroundColor = System.Drawing.SystemColors.ControlDark;
			cellLayout13.HeaderBackgroundGradiantColor = System.Drawing.SystemColors.ControlLight;
			cellLayout13.HorzAlign = System.Drawing.StringAlignment.Near;
			cellLayout13.ImageIndex_Select = -1;
			cellLayout13.ImageIndex_UnSelect = -1;
			lineOption19.Color = System.Drawing.Color.LightGray;
			lineOption19.Use = false;
			lineOption19.Width = 1;
			cellLayout13.LineBottom = lineOption19;
			lineOption110.Color = System.Drawing.Color.LightGray;
			lineOption110.Use = false;
			lineOption110.Width = 1;
			cellLayout13.LineLeft = lineOption110;
			lineOption111.Color = System.Drawing.Color.LightGray;
			lineOption111.Use = false;
			lineOption111.Width = 1;
			cellLayout13.LineRight = lineOption111;
			lineOption112.Color = System.Drawing.Color.LightGray;
			lineOption112.Use = false;
			lineOption112.Width = 1;
			cellLayout13.LineTop = lineOption112;
			cellLayout13.MinHeight = 19;
			cellLayout13.Name = "task";
			cellLayout13.Padding = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout13.SelectedColor = System.Drawing.SystemColors.Highlight;
			cellLayout13.Spacing = new System.Drawing.Rectangle(0, 0, 0, 0);
			cellLayout13.VertAlign = System.Drawing.StringAlignment.Near;
			this.gantt1.GridProperties.CellLayouts.Add(cellLayout11);
			this.gantt1.GridProperties.CellLayouts.Add(cellLayout12);
			this.gantt1.GridProperties.CellLayouts.Add(cellLayout13);
			gridColumn11.AllowMove = true;
			gridColumn11.AllowResize = true;
			gridColumn11.ColumnDerivedFromDS = false;
			gridColumn11.DataSourceColumn = "Name";
			gridColumn11.DataSourceColumnType = null;
			gridColumn11.Hide = false;
			gridColumn11.LayoutName = "Default";
			gridColumn11.ReadOnly = false;
			gridColumn11.Title = "Name";
			gridColumn11.Tree = true;
			gridColumn11.Type = PlexityHide.GTP.CellType.SingleText;
			gridColumn11.Width = 350;
			this.gantt1.GridProperties.Columns.Add(gridColumn11);
			this.gantt1.GridProperties.DrawPyjamas = true;
			this.gantt1.GridProperties.HasHeader = true;
			this.gantt1.GridProperties.ImageList = null;
			this.gantt1.GridProperties.PyjamasColor = System.Drawing.Color.White;
			this.gantt1.GridProperties.PyjamasGradientColor = System.Drawing.Color.WhiteSmoke;
			this.gantt1.GridProperties.RootNodes_DataMember = null;
			this.gantt1.GridProperties.RootNodes_DataSource = null;
			this.gantt1.GridWidth = 350;
			this.gantt1.ImageList = null;
			this.gantt1.Location = new System.Drawing.Point(8, 8);
			this.gantt1.Name = "gantt1";
			this.gantt1.PyjamasColor = System.Drawing.Color.WhiteSmoke;
			this.gantt1.PyjamasGradientColor = System.Drawing.Color.White;
			this.gantt1.Size = new System.Drawing.Size(780, 476);
			this.gantt1.TabIndex = 0;
			this.gantt1.Text = "gantt1";
			timeItemLayout11.AllowChangeRow = false;
			timeItemLayout11.AllowMove = true;
			timeItemLayout11.AllowResizeEast = false;
			timeItemLayout11.AllowResizeWest = false;
			timeItemLayout11.BottomInset = 10;
			timeItemLayout11.BrushKind = PlexityHide.GTP.BrushKind.Solid;
			timeItemLayout11.Color = System.Drawing.Color.DodgerBlue;
			timeItemLayout11.FixedSize = 16;
			timeItemLayout11.FixedSizeUse = false;
			timeItemLayout11.FrameColor = System.Drawing.Color.Black;
			timeItemLayout11.GradientColor = System.Drawing.Color.RoyalBlue;
			timeItemLayout11.HatchStyle = System.Drawing.Drawing2D.HatchStyle.Horizontal;
			timeItemLayout11.ImageIndex = 0;
			timeItemLayout11.Name = "proj";
			timeItemLayout11.SelectHandles = System.Drawing.Color.Empty;
			timeItemLayout11.Shadow = true;
			timeItemLayout11.ShadowColor = System.Drawing.Color.Gray;
			timeItemLayout11.SnapStartTime = System.TimeSpan.Parse("00:00:00");
			timeItemLayout11.SnapStopTime = System.TimeSpan.Parse("00:00:00");
			timeItemLayout11.TimeItemStyle = PlexityHide.GTP.TimeItemStyle.SpanWithTimeInPoint;
			timeItemLayout11.TopInset = 10;
			timeItemLayout12.AllowChangeRow = true;
			timeItemLayout12.AllowMove = true;
			timeItemLayout12.AllowResizeEast = true;
			timeItemLayout12.AllowResizeWest = true;
			timeItemLayout12.BottomInset = 0;
			timeItemLayout12.BrushKind = PlexityHide.GTP.BrushKind.GradientDiagonal;
			timeItemLayout12.Color = System.Drawing.Color.Yellow;
			timeItemLayout12.FixedSize = 16;
			timeItemLayout12.FixedSizeUse = false;
			timeItemLayout12.FrameColor = System.Drawing.Color.Black;
			timeItemLayout12.GradientColor = System.Drawing.Color.Gold;
			timeItemLayout12.HatchStyle = System.Drawing.Drawing2D.HatchStyle.Horizontal;
			timeItemLayout12.ImageIndex = 0;
			timeItemLayout12.Name = "work";
			timeItemLayout12.SelectHandles = System.Drawing.Color.Black;
			timeItemLayout12.Shadow = false;
			timeItemLayout12.ShadowColor = System.Drawing.Color.DeepPink;
			timeItemLayout12.SnapStartTime = System.TimeSpan.Parse("00:00:00");
			timeItemLayout12.SnapStopTime = System.TimeSpan.Parse("00:00:00");
			timeItemLayout12.TimeItemStyle = PlexityHide.GTP.TimeItemStyle.Square;
			timeItemLayout12.TopInset = 0;
			this.gantt1.TimeItemLayouts.Add(timeItemLayout11);
			this.gantt1.TimeItemLayouts.Add(timeItemLayout12);
			this.gantt1.TodayLine = true;
			this.gantt1.VerticalDayStripes = false;
			this.gantt1.VerticalDayStripes_Days = new bool[] {
					true,
					false,
					false,
					false,
					false,
					false,
					true};
			this.gantt1.VerticalLines = true;
			this.gantt1.OnNodeInserted += new PlexityHide.GTP.NodeEventHandler(this.gantt1_OnNodeInserted);
			this.gantt1.OnTimeItem_ChangeRow += new PlexityHide.GTP.TimeItemEvent(this.gantt1_OnTimeItem_ChangeRow);
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.mi_proj_New,
						this.mi_proj_Del,
						this.menuItem3,
						this.mi_ta_New,
						this.mi_ta_Del,
						this.menuItem6,
						this.mi_wi_New,
						this.mi_wi_Del,
						this.menuItem1,
						this.mi_AutoForm});
			this.contextMenu1.Popup += new System.EventHandler(this.contextMenu1_Popup);
			// 
			// mi_proj_New
			// 
			this.mi_proj_New.Index = 0;
			this.mi_proj_New.Text = "New project";
			this.mi_proj_New.Click += new System.EventHandler(this.mi_proj_New_Click);
			// 
			// mi_proj_Del
			// 
			this.mi_proj_Del.Index = 1;
			this.mi_proj_Del.Text = "Remove project";
			this.mi_proj_Del.Click += new System.EventHandler(this.mi_proj_Del_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "-";
			// 
			// mi_ta_New
			// 
			this.mi_ta_New.Index = 3;
			this.mi_ta_New.Text = "New task";
			this.mi_ta_New.Click += new System.EventHandler(this.mi_ta_New_Click);
			// 
			// mi_ta_Del
			// 
			this.mi_ta_Del.Index = 4;
			this.mi_ta_Del.Text = "Remove task";
			this.mi_ta_Del.Click += new System.EventHandler(this.mi_ta_Del_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 5;
			this.menuItem6.Text = "-";
			// 
			// mi_wi_New
			// 
			this.mi_wi_New.Index = 6;
			this.mi_wi_New.Text = "New work item";
			this.mi_wi_New.Click += new System.EventHandler(this.mi_wi_New_Click);
			// 
			// mi_wi_Del
			// 
			this.mi_wi_Del.Index = 7;
			this.mi_wi_Del.Text = "Remove work item";
			this.mi_wi_Del.Click += new System.EventHandler(this.mi_wi_Del_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 8;
			this.menuItem1.Text = "-";
			// 
			// mi_AutoForm
			// 
			this.mi_AutoForm.Index = 9;
			this.mi_AutoForm.Text = "Show ECO auto form";
			this.mi_AutoForm.Click += new System.EventHandler(this.mi_AutoForm_Click);
			// 
			// expressionHandle_projects
			// 
			oclColumn11.Expression = "self.Name";
			oclColumn11.Name = "name";
			eventDerivedColumn11.Name = "Start";
			eventDerivedColumn11.TypeName = "System.DateTime";
			eventDerivedColumn12.IsReadOnly = true;
			eventDerivedColumn12.Name = "Stop";
			eventDerivedColumn12.TypeName = "System.DateTime";
			this.expressionHandle_projects.Columns.AddRange(new Borland.Eco.Handles.AbstractColumn[] {
						oclColumn11,
						eventDerivedColumn11,
						eventDerivedColumn12});
			this.expressionHandle_projects.Expression = "Project.allInstances";
			this.expressionHandle_projects.RootHandle = this.rhRoot;
			this.expressionHandle_projects.DeriveValue += new Borland.Eco.Handles.DeriveEventHandler(this.expressionHandle_projects_DeriveValue);
			this.expressionHandle_projects.ReverseDeriveValue += new Borland.Eco.Handles.ReverseDeriveEventHandler(this.expressionHandle_projects_ReverseDeriveValue);
			//
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(808, 502);
			this.Controls.Add(this.gantt1);
			this.Name = "WinForm";
			this.Text = "WinForm";
			this.Load += new System.EventHandler(this.WinForm_Load);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		[STAThread]
		static void Main()
		{
			WinFormDequeuer.Active = true;
			Application.Run(new WinForm());
		}

		private void AddWorkItems(Task t)
		{
			WorkItem wi=new WorkItem(EcoSpace);
			wi.Task=t;
			wi.Start=gantt1.DateScaler.StartTime.AddDays(2);
			wi.Stop=wi.Start.AddDays(7);

			wi=new WorkItem(EcoSpace);
			wi.Task=t;
			wi.Start=gantt1.DateScaler.StartTime.AddDays(10);
			wi.Stop=wi.Start.AddDays(7);


		}
		private void WinForm_Load(object sender, System.EventArgs e)
		{
			if (expressionHandle_projects.GetList().Count==0)
			{
				Project p=new Project(EcoSpace);
				p.Name="Hello world project";
				Task t=new Task(EcoSpace);
				p.Task.Add(t);
				t.Name="Hello world task #1";
				AddWorkItems(t);
				t=new Task(EcoSpace);
				p.Task.Add(t);
				t.Name="Hello world task #2";
				AddWorkItems(t);

				Task t2=new Task(EcoSpace);
				t.subtasks.Add(t2);
				t2.Name="Hello world sub task #1 to task #2";
				AddWorkItems(t2);
				t2=new Task(EcoSpace);
				t.subtasks.Add(t2);
				t2.Name="Hello world sub task #2 to task #2";
				AddWorkItems(t2);
			}

			gantt1.GridProperties.RootNodes_DataSourceList=expressionHandle_projects.GetList();



		}

		private void gantt1_OnNodeInserted(PlexityHide.GTP.Grid aGrid, PlexityHide.GTP.NodeEventArgs e)
		{
			RenderedTuple tp=e.GridNode.ListItemWhenDataBound() as RenderedTuple;
			ReferenceHandle rh= new ReferenceHandle();
			rh.EcoSpace=rhRoot.EcoSpace;
			rh.SetElement(tp.Element);

			// Set up data bindings for sub nodes and time items
			if (tp.Element.AsObject is Project)
			{
				// a Project
				ExpressionHandle tasks=new ExpressionHandle();
				OclColumn namecol=new OclColumn();
				namecol.Expression="Name";
				tasks.Columns.Add(namecol);
				tasks.Expression = "self.Task->select(owner->isempty())";

				tasks.RootHandle = rh;

				e.GridNode.GetCell(0).Layout=gantt1.Grid.CellLayouts.GetFromName("proj");
				e.GridNode.SubNodes_DataSourceList=tasks.GetList();

				// Set up derived columns to show Project span
				EventDerivedColumn eStart=new EventDerivedColumn();
				EventDerivedColumn eStop=new EventDerivedColumn();
				eStart.IsReadOnly = false;
				eStart.Name = "Start";
				eStart.TypeName = "System.DateTime";
				eStop.IsReadOnly = true;
				eStop.Name = "Stop";
				eStop.TypeName = "System.DateTime";
				rh.Columns.Add(eStart);
				rh.Columns.Add(eStop);
				rh.DeriveValue += new DeriveEventHandler(expressionHandle_projects_DeriveValue);
				rh.ReverseDeriveValue += new Borland.Eco.Handles.ReverseDeriveEventHandler(this.expressionHandle_projects_ReverseDeriveValue);

				Layer ProjSpanLayer=GanttRow.FromGridNode(e.GridNode).Layers[0];
				ProjSpanLayer.NameInDS_Start="Start";
				ProjSpanLayer.NameInDS_Stop="Stop";
				ProjSpanLayer.TimeItemLayout="proj";
				ProjSpanLayer.DataSourceList=rh.GetList();

			}
			else
			if (tp.Element.AsObject is Task)
			{
				// a Task

				ExpressionHandle tasks=new ExpressionHandle();
				OclColumn namecol=new OclColumn();
				namecol.Expression="Name";
				tasks.Columns.Add(namecol);
				tasks.Expression = "subtasks";

				tasks.RootHandle = rh;

				e.GridNode.SubNodes_DataSourceList=tasks.GetList();
				e.GridNode.GetCell(0).Layout=gantt1.Grid.CellLayouts.GetFromName("task");

				// Set up work items
				ExpressionHandle workitems=new ExpressionHandle();
				OclColumn Startcol=new OclColumn();
				Startcol.Name="Start";
				Startcol.Expression="self.Start";
				workitems.Columns.Add(Startcol);
				OclColumn Stopcol=new OclColumn();
				Stopcol.Name="Stop";
				Stopcol.Expression="self.Stop";
				workitems.Columns.Add(Stopcol);

				workitems.Expression = "workitem";
				workitems.RootHandle = rh;
				// Note: I thought there should be some way to add all default columns in RT? workitems.CreateDefaultColumns(); does nothing?




				Layer WorkItemLayer=GanttRow.FromGridNode(e.GridNode).Layers[0];
				WorkItemLayer.NameInDS_Start="Start";
				WorkItemLayer.NameInDS_Stop="Stop";
				WorkItemLayer.TimeItemLayout="work";
				WorkItemLayer.DataSourceList=workitems.GetList();

			}
		}

		private  object cmHitObject=null;
		private DateTime timeForNewWorkItems;
		private Task taskForNewWorkItems;
		private void contextMenu1_Popup(object sender, System.EventArgs e)
		{
			mi_proj_New.Enabled=true;
			mi_proj_Del.Enabled=false;
			mi_ta_New.Enabled=false;
			mi_ta_Del.Enabled=false;
			mi_wi_New.Enabled=false;
			mi_wi_Del.Enabled=false;
			mi_AutoForm.Enabled=false;
			cmHitObject=null;
			taskForNewWorkItems=null;

			Point gp=gantt1.Grid.PointToClient(MousePosition);
			Cell c=gantt1.Grid.GridStructure.CellFromXY(gp.X,gp.Y);
			if (c!=null)
			{
				cmHitObject=(c.Node.ListItemWhenDataBound() as RenderedTuple).Element.AsObject;
				if((c.Node.ListItemWhenDataBound() as RenderedTuple).Element.AsObject is Project)
				{
					mi_proj_Del.Enabled=true;
					mi_ta_New.Enabled=true;
				}
				else
				if((c.Node.ListItemWhenDataBound() as RenderedTuple).Element.AsObject is Task)
				{
					mi_ta_New.Enabled=true;
					mi_ta_Del.Enabled=true;
					mi_wi_New.Enabled=true;
				}


			}
			else
			{
				Point tiap=gantt1.TimeItemArea.PointToClient(MousePosition);

				GanttRow gr=gantt1.GanttRowFromY(tiap.Y);
				if (gr!=null)
				{
					timeForNewWorkItems=gantt1.DateScaler.PixelToTime(tiap.X);
					mi_wi_New.Enabled=(gr.GridNode.ListItemWhenDataBound() as RenderedTuple).Element.AsObject is Task;
					if (mi_wi_New.Enabled)
						taskForNewWorkItems=(gr.GridNode.ListItemWhenDataBound() as RenderedTuple).Element.AsObject as Task;

					TimeItem ti=gr.TimeItemFromXY(tiap.X,tiap.Y);
					if (ti!=null)
					{
						cmHitObject=(ti.ListItemWhenDataBound() as RenderedTuple).Element.AsObject;
						mi_wi_Del.Enabled=true;
					}
				}
			}

			if (cmHitObject!=null)
				mi_AutoForm.Enabled=true;

		}

		private void mi_AutoForm_Click(object sender, System.EventArgs e)
		{
		   // No idea on how to set this up currently, sorry
/*		   if (cmHitObject!=null)
			EcoSpace.UndoService.
			(cmHitObject as Task).AsIObject().ServiceProvider.GetEcoService()
  */
		}

		private void mi_proj_New_Click(object sender, System.EventArgs e)
		{
			Project p=new Project(EcoSpace);
			p.Name="New Project";
		}

		private void mi_proj_Del_Click(object sender, System.EventArgs e)
		{
			(cmHitObject as Project).AsIObject().Delete();
		}

		private void mi_ta_New_Click(object sender, System.EventArgs e)
		{
			Task t=new Task(EcoSpace);
			t.Name="New Task";

			if (cmHitObject is Task)
				t.owner=cmHitObject as Task;
			else
			if (cmHitObject is Project)
				t.Project=cmHitObject as Project;

		}

		private void mi_ta_Del_Click(object sender, System.EventArgs e)
		{
			(cmHitObject as Task).AsIObject().Delete();
		}

		private void mi_wi_New_Click(object sender, System.EventArgs e)
		{
			WorkItem wi=new WorkItem(EcoSpace);
			wi.Start=timeForNewWorkItems;
			wi.Stop=wi.Start.AddDays(3);
			wi.Task=taskForNewWorkItems;

		}

		private void mi_wi_Del_Click(object sender, System.EventArgs e)
		{
			(cmHitObject as WorkItem).AsIObject().Delete();
		}

		private void gantt1_OnTimeItem_ChangeRow(PlexityHide.GTP.Gantt aGantt, PlexityHide.GTP.TimeItemEventArgs e)
		{

			e.Allow=false; // Ignore the components attempt to change row,
			if ((e.NewGanttRow.GridNode.ListItemWhenDataBound() as RenderedTuple).Element.AsObject is Task &&
				 (e.TimeItem.GanttRow.GridNode.ListItemWhenDataBound() as RenderedTuple).Element.AsObject is Task)
			{
				// When we change the ECO objects the GUI will be updated automatically
				WorkItem wi=(e.TimeItem.ListItemWhenDataBound() as RenderedTuple).Element.AsObject as WorkItem;
				wi.Task=(e.NewGanttRow.GridNode.ListItemWhenDataBound() as RenderedTuple).Element.AsObject as Task;

			}
		}

		private void TraverseTaskAndFind(Task t,bool LowNotHigh,ref DateTime x,Borland.Eco.Subscription.ISubscriber subs)
		{
			for (int i=0;i<t.WorkItem.Count;i++)
			{
				if (LowNotHigh)
				{
					if (t.WorkItem[i].Start<x)
						x=t.WorkItem[i].Start;
				}
				else
				{
					if (t.WorkItem[i].Stop>x)
						x=t.WorkItem[i].Stop;
				}
			}
			for (int i=0;i<t.subtasks.Count;i++)
			{
				TraverseTaskAndFind(t.subtasks[i],LowNotHigh,ref x,subs);
			}
			if (LowNotHigh)
				EcoSpace.OclService.EvaluateAndSubscribe(t.AsIObject(),"self.WorkItem.Start",subs,subs);
			else
				EcoSpace.OclService.EvaluateAndSubscribe(t.AsIObject(),"self.WorkItem.Stop",subs,subs);

			EcoSpace.OclService.EvaluateAndSubscribe(t.AsIObject(),"subtasks",subs,subs);
		}
		private DateTime TraverseProjectAndFind(Project p,bool LowNotHigh,Borland.Eco.Subscription.ISubscriber subs)
		{
			DateTime x=DateTime.MaxValue;
			if (!LowNotHigh)
				x=DateTime.MinValue;
			for (int i=0;i<p.Task.Count;i++)
			{
				TraverseTaskAndFind(p.Task[i],LowNotHigh,ref x,subs);
			}

			EcoSpace.OclService.EvaluateAndSubscribe(p.AsIObject(),"task",subs,subs);

			return x;
		}

		private void expressionHandle_projects_DeriveValue(object sender, Borland.Eco.Handles.DeriveEventArgs e)
		{
			Project p=(e.RootElement.AsObject as Project);
			if (e.Name=="Start")
			{
				DateTime x=DateTime.MaxValue;
				e.ResultElement=EcoSpace.VariableFactoryService.CreateVariable(x.GetType());
				e.ResultElement.AsObject=TraverseProjectAndFind(p,true,e.ResubscribeSubscriber);
			}
			else
			if (e.Name=="Stop")
			{
				DateTime x=DateTime.MaxValue;
				e.ResultElement=EcoSpace.VariableFactoryService.CreateVariable(x.GetType());
				(e.ResultElement.AsObject)=TraverseProjectAndFind(p,false,e.ResubscribeSubscriber);

			}

		}

		private void MoveAllWorkItems(Task t,TimeSpan ts)
		{
			for (int i=0;i<t.WorkItem.Count;i++)
			{
				t.WorkItem[i].Start=t.WorkItem[i].Start.Add(ts);
				t.WorkItem[i].Stop=t.WorkItem[i].Stop.Add(ts);
			}
			for (int i=0;i<t.subtasks.Count;i++)
				MoveAllWorkItems(t.subtasks[i],ts);
		}

		private void MoveAllWorkItems(Project p,TimeSpan ts)
		{
			for (int i=0;i<p.Task.Count;i++)
			{
				MoveAllWorkItems(p.Task[i],ts);
			}
		}


		private void expressionHandle_projects_ReverseDeriveValue(object sender, Borland.Eco.Handles.ReverseDeriveEventArgs e)
		{
			Project p=(e.RootElement.AsObject as Project);
			if (e.Name=="Start")
			{
				//ReferenceHandle rf=(e.ServiceProvider as ReferenceHandle);
				//rf.RenderElement()

				DateTime x=TraverseProjectAndFind(p,true,null);
				TimeSpan moveThisMuch=((DateTime)e.Value).Subtract(x);
				MoveAllWorkItems(p,moveThisMuch);
			}
		}

	}
}
